test-lib: unset GIT_NOTES_REF to stop it from influencing tests
[git/kirr.git] / t / test-lib.sh
blob49f06d2b844548cc23d52a9b9e56648bdc0c52c5
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10 # do not redirect again
12 *' --tee '*|*' --va'*)
13 mkdir -p test-results
14 BASE=test-results/$(basename "$0" .sh)
15 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $? > $BASE.exit) | tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
18 exit
20 esac
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 unset VISUAL
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 unset GIT_NOTES_REF
58 GIT_MERGE_VERBOSITY=5
59 export GIT_MERGE_VERBOSITY
60 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
61 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
62 export EDITOR
63 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
65 # Protect ourselves from common misconfiguration to export
66 # CDPATH into the environment
67 unset CDPATH
69 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
70 1|2|true)
71 echo "* warning: Some tests will not work if GIT_TRACE" \
72 "is set as to trace on STDERR ! *"
73 echo "* warning: Please set GIT_TRACE to something" \
74 "other than 1, 2 or true ! *"
76 esac
78 # Each test should start with something like this, after copyright notices:
80 # test_description='Description of this test...
81 # This test checks if command xyzzy does the right thing...
82 # '
83 # . ./test-lib.sh
84 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
85 TERM=$ORIGINAL_TERM &&
86 export TERM &&
87 [ -t 1 ] &&
88 tput bold >/dev/null 2>&1 &&
89 tput setaf 1 >/dev/null 2>&1 &&
90 tput sgr0 >/dev/null 2>&1
91 ) &&
92 color=t
94 while test "$#" -ne 0
96 case "$1" in
97 -d|--d|--de|--deb|--debu|--debug)
98 debug=t; shift ;;
99 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
100 immediate=t; shift ;;
101 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
102 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
103 -h|--h|--he|--hel|--help)
104 help=t; shift ;;
105 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
106 verbose=t; shift ;;
107 -q|--q|--qu|--qui|--quie|--quiet)
108 quiet=t; shift ;;
109 --with-dashes)
110 with_dashes=t; shift ;;
111 --no-color)
112 color=; shift ;;
113 --no-python)
114 # noop now...
115 shift ;;
116 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
117 valgrind=t; verbose=t; shift ;;
118 --tee)
119 shift ;; # was handled already
120 --root=*)
121 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
122 shift ;;
124 echo "error: unknown test option '$1'" >&2; exit 1 ;;
125 esac
126 done
128 if test -n "$color"; then
129 say_color () {
131 TERM=$ORIGINAL_TERM
132 export TERM
133 case "$1" in
134 error) tput bold; tput setaf 1;; # bold red
135 skip) tput bold; tput setaf 2;; # bold green
136 pass) tput setaf 2;; # green
137 info) tput setaf 3;; # brown
138 *) test -n "$quiet" && return;;
139 esac
140 shift
141 printf "* %s" "$*"
142 tput sgr0
143 echo
146 else
147 say_color() {
148 test -z "$1" && test -n "$quiet" && return
149 shift
150 echo "* $*"
154 error () {
155 say_color error "error: $*"
156 GIT_EXIT_OK=t
157 exit 1
160 say () {
161 say_color info "$*"
164 test "${test_description}" != "" ||
165 error "Test script did not set test_description."
167 if test "$help" = "t"
168 then
169 echo "$test_description"
170 exit 0
173 exec 5>&1
174 if test "$verbose" = "t"
175 then
176 exec 4>&2 3>&1
177 else
178 exec 4>/dev/null 3>/dev/null
181 test_failure=0
182 test_count=0
183 test_fixed=0
184 test_broken=0
185 test_success=0
187 die () {
188 code=$?
189 if test -n "$GIT_EXIT_OK"
190 then
191 exit $code
192 else
193 echo >&5 "FATAL: Unexpected exit with code $code"
194 exit 1
198 GIT_EXIT_OK=
199 trap 'die' EXIT
201 # The semantics of the editor variables are that of invoking
202 # sh -c "$EDITOR \"$@\"" files ...
204 # If our trash directory contains shell metacharacters, they will be
205 # interpreted if we just set $EDITOR directly, so do a little dance with
206 # environment variables to work around this.
208 # In particular, quoting isn't enough, as the path may contain the same quote
209 # that we're using.
210 test_set_editor () {
211 FAKE_EDITOR="$1"
212 export FAKE_EDITOR
213 EDITOR='"$FAKE_EDITOR"'
214 export EDITOR
217 test_decode_color () {
218 sed -e 's/.\[1m/<WHITE>/g' \
219 -e 's/.\[31m/<RED>/g' \
220 -e 's/.\[32m/<GREEN>/g' \
221 -e 's/.\[33m/<YELLOW>/g' \
222 -e 's/.\[34m/<BLUE>/g' \
223 -e 's/.\[35m/<MAGENTA>/g' \
224 -e 's/.\[36m/<CYAN>/g' \
225 -e 's/.\[m/<RESET>/g'
228 test_tick () {
229 if test -z "${test_tick+set}"
230 then
231 test_tick=1112911993
232 else
233 test_tick=$(($test_tick + 60))
235 GIT_COMMITTER_DATE="$test_tick -0700"
236 GIT_AUTHOR_DATE="$test_tick -0700"
237 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
240 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
242 # This will commit a file with the given contents and the given commit
243 # message. It will also add a tag with <message> as name.
245 # Both <file> and <contents> default to <message>.
247 test_commit () {
248 file=${2:-"$1.t"}
249 echo "${3-$1}" > "$file" &&
250 git add "$file" &&
251 test_tick &&
252 git commit -m "$1" &&
253 git tag "$1"
256 # Call test_merge with the arguments "<message> <commit>", where <commit>
257 # can be a tag pointing to the commit-to-merge.
259 test_merge () {
260 test_tick &&
261 git merge -m "$1" "$2" &&
262 git tag "$1"
265 # This function helps systems where core.filemode=false is set.
266 # Use it instead of plain 'chmod +x' to set or unset the executable bit
267 # of a file in the working directory and add it to the index.
269 test_chmod () {
270 chmod "$@" &&
271 git update-index --add "--chmod=$@"
274 # Use test_set_prereq to tell that a particular prerequisite is available.
275 # The prerequisite can later be checked for in two ways:
277 # - Explicitly using test_have_prereq.
279 # - Implicitly by specifying the prerequisite tag in the calls to
280 # test_expect_{success,failure,code}.
282 # The single parameter is the prerequisite tag (a simple word, in all
283 # capital letters by convention).
285 test_set_prereq () {
286 satisfied="$satisfied$1 "
288 satisfied=" "
290 test_have_prereq () {
291 case $satisfied in
292 *" $1 "*)
293 : yes, have it ;;
295 ! : nope ;;
296 esac
299 # You are not expected to call test_ok_ and test_failure_ directly, use
300 # the text_expect_* functions instead.
302 test_ok_ () {
303 test_success=$(($test_success + 1))
304 say_color "" " ok $test_count: $@"
307 test_failure_ () {
308 test_failure=$(($test_failure + 1))
309 say_color error "FAIL $test_count: $1"
310 shift
311 echo "$@" | sed -e 's/^/ /'
312 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
315 test_known_broken_ok_ () {
316 test_fixed=$(($test_fixed+1))
317 say_color "" " FIXED $test_count: $@"
320 test_known_broken_failure_ () {
321 test_broken=$(($test_broken+1))
322 say_color skip " still broken $test_count: $@"
325 test_debug () {
326 test "$debug" = "" || eval "$1"
329 test_run_ () {
330 eval >&3 2>&4 "$1"
331 eval_ret="$?"
332 return 0
335 test_skip () {
336 test_count=$(($test_count+1))
337 to_skip=
338 for skp in $GIT_SKIP_TESTS
340 case $this_test.$test_count in
341 $skp)
342 to_skip=t
343 esac
344 done
345 if test -z "$to_skip" && test -n "$prereq" &&
346 ! test_have_prereq "$prereq"
347 then
348 to_skip=t
350 case "$to_skip" in
352 say_color skip >&3 "skipping test: $@"
353 say_color skip "skip $test_count: $1"
354 : true
357 false
359 esac
362 test_expect_failure () {
363 test "$#" = 3 && { prereq=$1; shift; } || prereq=
364 test "$#" = 2 ||
365 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
366 if ! test_skip "$@"
367 then
368 say >&3 "checking known breakage: $2"
369 test_run_ "$2"
370 if [ "$?" = 0 -a "$eval_ret" = 0 ]
371 then
372 test_known_broken_ok_ "$1"
373 else
374 test_known_broken_failure_ "$1"
377 echo >&3 ""
380 test_expect_success () {
381 test "$#" = 3 && { prereq=$1; shift; } || prereq=
382 test "$#" = 2 ||
383 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
384 if ! test_skip "$@"
385 then
386 say >&3 "expecting success: $2"
387 test_run_ "$2"
388 if [ "$?" = 0 -a "$eval_ret" = 0 ]
389 then
390 test_ok_ "$1"
391 else
392 test_failure_ "$@"
395 echo >&3 ""
398 test_expect_code () {
399 test "$#" = 4 && { prereq=$1; shift; } || prereq=
400 test "$#" = 3 ||
401 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
402 if ! test_skip "$@"
403 then
404 say >&3 "expecting exit code $1: $3"
405 test_run_ "$3"
406 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
407 then
408 test_ok_ "$2"
409 else
410 test_failure_ "$@"
413 echo >&3 ""
416 # test_external runs external test scripts that provide continuous
417 # test output about their progress, and succeeds/fails on
418 # zero/non-zero exit code. It outputs the test output on stdout even
419 # in non-verbose mode, and announces the external script with "* run
420 # <n>: ..." before running it. When providing relative paths, keep in
421 # mind that all scripts run in "trash directory".
422 # Usage: test_external description command arguments...
423 # Example: test_external 'Perl API' perl ../path/to/test.pl
424 test_external () {
425 test "$#" = 4 && { prereq=$1; shift; } || prereq=
426 test "$#" = 3 ||
427 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
428 descr="$1"
429 shift
430 if ! test_skip "$descr" "$@"
431 then
432 # Announce the script to reduce confusion about the
433 # test output that follows.
434 say_color "" " run $test_count: $descr ($*)"
435 # Run command; redirect its stderr to &4 as in
436 # test_run_, but keep its stdout on our stdout even in
437 # non-verbose mode.
438 "$@" 2>&4
439 if [ "$?" = 0 ]
440 then
441 test_ok_ "$descr"
442 else
443 test_failure_ "$descr" "$@"
448 # Like test_external, but in addition tests that the command generated
449 # no output on stderr.
450 test_external_without_stderr () {
451 # The temporary file has no (and must have no) security
452 # implications.
453 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
454 stderr="$tmp/git-external-stderr.$$.tmp"
455 test_external "$@" 4> "$stderr"
456 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
457 descr="no stderr: $1"
458 shift
459 say >&3 "expecting no stderr from previous command"
460 if [ ! -s "$stderr" ]; then
461 rm "$stderr"
462 test_ok_ "$descr"
463 else
464 if [ "$verbose" = t ]; then
465 output=`echo; echo Stderr is:; cat "$stderr"`
466 else
467 output=
469 # rm first in case test_failure exits.
470 rm "$stderr"
471 test_failure_ "$descr" "$@" "$output"
475 # This is not among top-level (test_expect_success | test_expect_failure)
476 # but is a prefix that can be used in the test script, like:
478 # test_expect_success 'complain and die' '
479 # do something &&
480 # do something else &&
481 # test_must_fail git checkout ../outerspace
484 # Writing this as "! git checkout ../outerspace" is wrong, because
485 # the failure could be due to a segv. We want a controlled failure.
487 test_must_fail () {
488 "$@"
489 test $? -gt 0 -a $? -le 129 -o $? -gt 192
492 # test_cmp is a helper function to compare actual and expected output.
493 # You can use it like:
495 # test_expect_success 'foo works' '
496 # echo expected >expected &&
497 # foo >actual &&
498 # test_cmp expected actual
501 # This could be written as either "cmp" or "diff -u", but:
502 # - cmp's output is not nearly as easy to read as diff -u
503 # - not all diff versions understand "-u"
505 test_cmp() {
506 $GIT_TEST_CMP "$@"
509 # Most tests can use the created repository, but some may need to create more.
510 # Usage: test_create_repo <directory>
511 test_create_repo () {
512 test "$#" = 1 ||
513 error "bug in the test script: not 1 parameter to test-create-repo"
514 owd=`pwd`
515 repo="$1"
516 mkdir -p "$repo"
517 cd "$repo" || error "Cannot setup test environment"
518 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
519 error "cannot run git init -- have you built things yet?"
520 mv .git/hooks .git/hooks-disabled
521 cd "$owd"
524 test_done () {
525 GIT_EXIT_OK=t
526 test_results_dir="$TEST_DIRECTORY/test-results"
527 mkdir -p "$test_results_dir"
528 test_results_path="$test_results_dir/${0%.sh}-$$"
530 echo "total $test_count" >> $test_results_path
531 echo "success $test_success" >> $test_results_path
532 echo "fixed $test_fixed" >> $test_results_path
533 echo "broken $test_broken" >> $test_results_path
534 echo "failed $test_failure" >> $test_results_path
535 echo "" >> $test_results_path
537 if test "$test_fixed" != 0
538 then
539 say_color pass "fixed $test_fixed known breakage(s)"
541 if test "$test_broken" != 0
542 then
543 say_color error "still have $test_broken known breakage(s)"
544 msg="remaining $(($test_count-$test_broken)) test(s)"
545 else
546 msg="$test_count test(s)"
548 case "$test_failure" in
550 say_color pass "passed all $msg"
552 test -d "$remove_trash" &&
553 cd "$(dirname "$remove_trash")" &&
554 rm -rf "$(basename "$remove_trash")"
556 exit 0 ;;
559 say_color error "failed $test_failure among $msg"
560 exit 1 ;;
562 esac
565 # Test the binaries we have just built. The tests are kept in
566 # t/ subdirectory and are run in 'trash directory' subdirectory.
567 TEST_DIRECTORY=$(pwd)
568 if test -n "$valgrind"
569 then
570 make_symlink () {
571 test -h "$2" &&
572 test "$1" = "$(readlink "$2")" || {
573 # be super paranoid
574 if mkdir "$2".lock
575 then
576 rm -f "$2" &&
577 ln -s "$1" "$2" &&
578 rm -r "$2".lock
579 else
580 while test -d "$2".lock
582 say "Waiting for lock on $2."
583 sleep 1
584 done
589 make_valgrind_symlink () {
590 # handle only executables
591 test -x "$1" || return
593 base=$(basename "$1")
594 symlink_target=$TEST_DIRECTORY/../$base
595 # do not override scripts
596 if test -x "$symlink_target" &&
597 test ! -d "$symlink_target" &&
598 test "#!" != "$(head -c 2 < "$symlink_target")"
599 then
600 symlink_target=../valgrind.sh
602 case "$base" in
603 *.sh|*.perl)
604 symlink_target=../unprocessed-script
605 esac
606 # create the link, or replace it if it is out of date
607 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
610 # override all git executables in TEST_DIRECTORY/..
611 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
612 mkdir -p "$GIT_VALGRIND"/bin
613 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
615 make_valgrind_symlink $file
616 done
617 OLDIFS=$IFS
618 IFS=:
619 for path in $PATH
621 ls "$path"/git-* 2> /dev/null |
622 while read file
624 make_valgrind_symlink "$file"
625 done
626 done
627 IFS=$OLDIFS
628 PATH=$GIT_VALGRIND/bin:$PATH
629 GIT_EXEC_PATH=$GIT_VALGRIND/bin
630 export GIT_VALGRIND
631 elif test -n "$GIT_TEST_INSTALLED" ; then
632 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
633 error "Cannot run git from $GIT_TEST_INSTALLED."
634 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
635 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
636 else # normal case, use ../bin-wrappers only unless $with_dashes:
637 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
638 if ! test -x "$git_bin_dir/git" ; then
639 if test -z "$with_dashes" ; then
640 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
642 with_dashes=t
644 PATH="$git_bin_dir:$PATH"
645 GIT_EXEC_PATH=$TEST_DIRECTORY/..
646 if test -n "$with_dashes" ; then
647 PATH="$TEST_DIRECTORY/..:$PATH"
650 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
651 unset GIT_CONFIG
652 GIT_CONFIG_NOSYSTEM=1
653 GIT_CONFIG_NOGLOBAL=1
654 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
656 . ../GIT-BUILD-OPTIONS
658 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
659 export GITPERLLIB
660 test -d ../templates/blt || {
661 error "You haven't built things yet, have you?"
664 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
665 then
666 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
667 export GITPYTHONLIB
668 test -d ../git_remote_helpers/build || {
669 error "You haven't built git_remote_helpers yet, have you?"
673 if ! test -x ../test-chmtime; then
674 echo >&2 'You need to build test-chmtime:'
675 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
676 exit 1
679 # Test repository
680 test="trash directory.$(basename "$0" .sh)"
681 test -n "$root" && test="$root/$test"
682 case "$test" in
683 /*) TRASH_DIRECTORY="$test" ;;
684 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
685 esac
686 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
687 rm -fr "$test" || {
688 GIT_EXIT_OK=t
689 echo >&5 "FATAL: Cannot prepare test area"
690 exit 1
693 test_create_repo "$test"
694 # Use -P to resolve symlinks in our working directory so that the cwd
695 # in subprocesses like git equals our $PWD (for pathname comparisons).
696 cd -P "$test" || exit 1
698 this_test=${0##*/}
699 this_test=${this_test%%-*}
700 for skp in $GIT_SKIP_TESTS
702 to_skip=
703 for skp in $GIT_SKIP_TESTS
705 case "$this_test" in
706 $skp)
707 to_skip=t
708 esac
709 done
710 case "$to_skip" in
712 say_color skip >&3 "skipping test $this_test altogether"
713 say_color skip "skip all tests in $this_test"
714 test_done
715 esac
716 done
718 # Provide an implementation of the 'yes' utility
719 yes () {
720 if test $# = 0
721 then
723 else
724 y="$*"
727 while echo "$y"
730 done
733 # Fix some commands on Windows
734 case $(uname -s) in
735 *MINGW*)
736 # Windows has its own (incompatible) sort and find
737 sort () {
738 /usr/bin/sort "$@"
740 find () {
741 /usr/bin/find "$@"
743 sum () {
744 md5sum "$@"
746 # git sees Windows-style pwd
747 pwd () {
748 builtin pwd -W
750 # no POSIX permissions
751 # backslashes in pathspec are converted to '/'
752 # exec does not inherit the PID
755 test_set_prereq POSIXPERM
756 test_set_prereq BSLASHPSPEC
757 test_set_prereq EXECKEEPSPID
759 esac
761 test -z "$NO_PERL" && test_set_prereq PERL
762 test -z "$NO_PYTHON" && test_set_prereq PYTHON
764 # test whether the filesystem supports symbolic links
765 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
766 rm -f y